首页
学习
活动
专区
圈层
工具
发布

【详解】使用Java解决 - 输入数组,最大的与第一个元素交换,最小的与最后一个元素交换,输出数组

使用Java解决 - 输入数组,最大的与第一个元素交换,最小的与最后一个元素交换,输出数组在编程中,数组操作是常见的任务之一。...本文将介绍如何使用Java实现一个简单的算法:给定一个整数数组,将数组中的最大值与第一个元素交换位置,将最小值与最后一个元素交换位置,最后输出处理后的数组。1....问题描述给定一个整数数组 ​​arr​​,我们需要完成以下操作:找出数组中的最大值,并将其与数组的第一个元素交换。找出数组中的最小值,并将其与数组的最后一个元素交换。输出最终的数组。2....输出结果:打印处理后的数组。3....初始化最大值和最小值的索引,以及第一个和最后一个元素的值。遍历数组找到最大值和最小值的索引。交换最大值和第一个元素,最小值和最后一个元素。

24510

在排序数组中查找元素的第一个和最后一个位置

在排序数组中查找元素的第一个和最后一个位置 给你一个按照非递减顺序排列的整数数组 nums,和一个目标值 target。请你找出给定目标值在数组中的开始位置和结束位置。...我们将这道题拆解成两个部分,第一部分就是求该元素的左端点,另一部分就是求该元素的右端点。其实这两部分是大同小异,只要弄懂其中一个,另一个就迎刃而解! 我们首先来讲第一部分——求该元素的左端点。...第一步将这些数据分为两个部分:小于元素和大于等于该元素这两个部分。 第二步就是普通二分算法的代码 注意这里有一个细节,跟普通二分查找算法不同,也是后面细节的“万恶之源”。...因为左端点是将数据分为小于和大于等于,所以right = mid,如果这里采用第二种求中点方法,就会造成死循环,right的值一直都没有变化! 上面就是讲解左端点的解法,右端点也是大同小异。...int right = nums.size() - 1; int mid = 0; int begin = 0; while(left 第一个小细节

3.7K10
  • 您找到你想要的搜索结果了吗?
    是的
    没有找到

    在排序数组中查找元素的第一个和最后一个位置

    在排序数组中查找元素的第一个和最后一个位置 给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。...,-1] 示例 3: 输入:nums = [], target = 0 输出:[-1,-1] 思路 这道题目如果基础不是很好,不建议大家看简短的代码,简短的代码隐藏了太多逻辑,结果就是稀里糊涂把题AC了...刚刚接触二分搜索的同学不建议上来就像如果用一个二分来查找左右边界,很容易把自己绕进去,建议扎扎实实的写两个二分分别找左边界和右边界 寻找右边界 先来寻找右边界,至于二分查找,如果看过704.二分查找就会知道...target的下标(左边界)与第一个大于target的下标(右边界); # 2、如果左边界的下标leftBorder; # 2、在 nums 数组中二分查找得到第一个大于等于 target+1的下标, 减1则得到rightBorder; # 3、如果开始位置在数组的右边或者不存在

    8.1K20

    刷题2:在数组中查找元素的第一个和最后一个位置

    题目:给定一个的整数数组 nums, 和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。...题目解析: 1.给定一个数组,确定的是一个数组, 数组是整数,那么我们可以知道,那么target的也是整数。...2.要求target的在数组中开始位置和结束位置,我们可以先找出来target的在list里面的下标位置,把这些下标位置放到list里面,我们去取list里面的第一个元素和最后一个元素,就是对应的开始位置和结束位置...那么我们就可以上手去实现我们的代码了。 从这期开始,我们的代码将用python 和java两个版本去实现,同时从两方面去提高我们的,同时 也面向了两门语言的学习者。...那么我们测试完毕,根据测试覆盖率来说,我们目前的测试是已经完成了覆盖了百分之百的路径和代码。 后续会陆续给大家分享更多的题目,更多的代码,大家一起成长,一起刷题。

    3.8K20

    Leetcode No.34 在排序数组中查找元素的第一个和最后一个位置

    一、题目描述 给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。 如果数组中不存在目标值 target,返回 [-1, -1]。...109 nums 是一个非递减数组 -109 <= target <= 109 二、解题思路 使用二分法查找第一个位置,初始化两个变量low=0,hight=nums.length-1 1、当low...返回下标mid 5、当目标值小于等于nums[mid]时,说明目标值在左侧,往左侧递归查找,否则往右侧递归查找 查找最后一个位置同理,唯一不同的是第4、5步 4、假如nums[mid]等于target且...mid-1]<nums[mid])){ return mid; } if(target<=nums[mid]){ //寻找第一个位置...mid]<nums[mid+1]){ return mid; } if(target>=nums[mid]){ //寻找最后一个位置

    3.7K10

    leetcode34-在排序数组中查找元素的第一个和最后一个位置

    前言 今天刷的题目是:在排序数组中查找元素的第一个和最后一个位置,这道题目在最开始AC以后,然后做了两步的优化操作,供大家参考。...题目 leetcode-34:在排序数组中查找元素的第一个和最后一个位置 分类(tag):二分查找这一类 英文链接:https://leetcode.com/problems/find-first-and-last-position-of-element-in-sorted-array...nums,和一个目标值 target。...找出给定目标值在数组中的开始位置和结束位置。 你的算法时间复杂度必须是 O(log n) 级别。 如果数组中不存在目标值,返回 [-1, -1]。...-1,-1] 题目详解 思路 有序和数组这个两个字眼结合起来,肯定是要用到二分查找这一类; 首先就是找最左侧的下标,利用二分查找首先是找到有一个值是与目标值target是相等的,然后因为是找最左侧的下标

    4.4K30

    LeetCode-34-在排序数组中查找元素的第一个和最后一个位置

    # LeetCode-34-在排序数组中查找元素的第一个和最后一个位置 给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。...[-1,-1] # 解题思路 方法1、双指针暴力法(low): 特例判断: 当数组为空或数组长度为0时,直接返回[-1,1] 当数组长度为1时,判断第一个数字是否等于target,等于则返回[0,0...],否则返回[-1,-1] 初始化头尾指针 移动头指针,直到找到第一个等于target的位置,如果找完了都没有找到,返回[-1,-1] 移动尾指针,直到找到最后一个等于target的位置,如果找完了都没有找到...左方,end = mid-1 当nums[mid]==target时,说明左右边界有一个地方等于target,这时候只需要查找另外一个边界等于target的即可,可以进行循环移动查找,最后返回[start...,end]即可 如果没有找到,返回[-1,-1] 方法3、递归分治(low): 通过二分查找切分数组寻找左右子数组的target位置,迭代到只有一个,判断是否是目标值,返回一个都是当前index的数组,

    4K20

    LeetCode题目34:在排序数组中查找元素的第一个和最后一个位置

    原题描述 + 给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。 你的算法时间复杂度必须是 O(log n) 级别。...示例 1 输入: nums = [5,7,7,8,8,10], target = 8 输出: [3,4] 示例 2 输入: nums = [5,7,7,8,8,10], target = 6 输出: [...leetcode-cn.com/problems/find-first-and-last-position-of-element-in-sorted-array 思路解析 + 毫无疑问,时间复杂度O(log n)和升序数组...显然不能立即返回,应该让mid作为新的边界,再做一次二分查找,mid才能指向预期结果。...但如果复用上面的逻辑,每次挪动时令lower=mid+1,那么最终lower一定会与higher相撞于最后一个target的后一个位置。此时lower-1才是所求。

    4.6K20

    在排序数组中查找元素的第一个和最后一个位置

    前言 今天主要讲解的内容是:如何在已排序的数组中查找元素的第一个和最后一个位置。以 leetcode 34 题作为例题,提供二分查找的解题思路,供大家参考。...题目详述 给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。 如果数组中不存在目标值 target,返回 [-1, -1]。...1),不断向 mid 的左侧收缩,最后达到锁定左边界(元素的第一个位置)的目的; 如何查找元素的最后一个位置?...同查找元素的第一个位置类似,在查找到数组中某元素值等于目标值 target 时,不立即返回,通过增大查找区间的下边界 low (令 low = mid + 1),不断向 mid 的右侧收缩,最后达到锁定右边界...举栗 以 nums = [5,7,7,8,8,10], target = 8 为栗子,通过下图来找出目标值 8 在数组中出现的第一个和最后一个位置。

    4.1K20

    LeetCode144|在排序数组中查找元素的第一个和最后一个位置

    一,在排序数组中查找元素的第一个和最后一个位置 1,问题描述 给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。...如果数组中不存在目标值 target,返回 [-1, -1]。...2,示例描述 示例 1: 输入:nums = [5,7,7,8,8,10], target = 8 输出:[3,4] 示例 2: 输入:nums = [5,7,7,8,8,10], target =...6 输出:[-1,-1] 示例 3: 输入:nums = [], target = 0 输出:[-1,-1] 提示: 0 <= nums.length <= 105 -109 <= nums...[i] <= 109 nums 是一个非递减数组 -109 <= target <= 109 3,题解思路 本题基于我们最熟悉的集合LinkedHashMap键值对集合来做 4,题解程序 import

    3.7K20

    在排序数组中查找元素的第一个和最后一个位置(leetcode34)

    给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。 如果数组中不存在目标值 target,返回 [-1, -1]。...示例 1: 输入:nums = [5,7,7,8,8,10], target = 8 输出:[3,4] 解析: 方法一:二分查找 二分查找中,寻找leftIdx 即为在数组中寻找第一个大于等于 target...的下标,寻找 rightIdx 即为在数组中寻找第一个大于target 的下标,然后将下标减一。...两者的判断条件不同,为了代码的复用,我们定义 binarySearch(nums, target, lower) 表示在 nums 数组中二分查找 target 的位置,如果 lower 为 true,...则查找第一个大于等于 target 的下标,否则查找第一个大于target 的下标。

    3.3K10

    在排序数组中查找元素的第一个和最后一个位置--题解

    在排序数组中查找元素的第一个和最后一个位置 给定一个按照升序排列的整数数组 nums,和一个目标值 target。找出给定目标值在数组中的开始位置和结束位置。...如果数组中不存在目标值 target,返回 [-1, -1]。 进阶: 你可以设计并实现时间复杂度为 O(log n) 的算法解决此问题吗?...示例 1: 输入:nums = [5,7,7,8,8,10], target = 8 输出:[3,4] 示例 2: 输入:nums = [5,7,7,8,8,10], target = 6 输出:[-1...是一个非递减数组 -109 <= target <= 109 题解代码 func searchRange(nums []int, target int) []int { if len(nums) =...mid - 1 } else if nums[mid] == target { end = mid } else { start = mid + 1 } } //此处防止数组第一个数是

    3.3K30

    2024-05-22:用go语言,你有一个包含 n 个整数的数组 nums。 每个数组的代价是指该数组中的第一个元素的值。 你的

    2024-05-22:用go语言,你有一个包含 n 个整数的数组 nums。 每个数组的代价是指该数组中的第一个元素的值。 你的目标是将这个数组划分为三个连续且互不重叠的子数组。...然后,计算这三个子数组的代价之和, 要求返回这个和的最小值。 输入:nums = [1,2,3,12]。 输出:6。 答案2024-05-22: chatgpt 题目来自leetcode3010。...• 对于给定的数组 nums,迭代从第二个元素开始的所有元素: • 如果元素 x 小于当前最小值 fi,则将第二小值 se 更新为当前最小值 fi,并更新最小值为 x。...• 否则,如果元素 x介于当前最小值 fi 和第二小值 se 之间,则更新第二小值 se 为 x。 • 返回结果为数组第一个元素 nums[0] 与找到的两个最小值 fi 和 se 的和。...3.解问题: • 对于输入数组 [1, 2, 3, 12],算法将找到两个最小值为 1 和 2。 • 算法返回结果为 1 + 1 + 2 = 4,此结果表示划分三个子数组后的最小代价之和。

    1.4K10

    LeetCode - #34 在排序数组中查找元素的第一个和最后一个位置(Top 100)

    LeetCode 算法到目前我们已经更新了 33 期,我们会保持更新时间和进度(周一、周三、周五早上 9:00 发布),每期的内容不多,我们希望大家可以在上班路上阅读,长久积累会有很大提升。...如果大家有建议和意见欢迎在文末留言,我们会尽力满足大家的需求。 难度水平:中等 1. 描述 给定一个按照升序排列的整数数组 nums,和一个目标值 target。...找出给定目标值在数组中的开始位置和结束位置。 如果数组中不存在目标值 target,返回 [-1, -1]。 进阶: 你可以设计并实现时间复杂度为 O(log n) 的算法解决此问题吗? 2....示例 示例 1 输入:nums = [5,7,7,8,8,10], target = 8 输出:[3,4] 示例 2 输入:nums = [5,7,7,8,8,10], target = 6 输出:...10^9 nums 是一个非递减数组 -10^9 <= target <= 10^9 3.

    2.3K20

    2024-11-28:边界元素是最大值的子数组数目。用go语言,给定一个正整数数组 nums,需要找到满足子数组中第一个和最后一

    2024-11-28:边界元素是最大值的子数组数目。用go语言,给定一个正整数数组 nums,需要找到满足子数组中第一个和最后一个元素都是该子数组中的最大值的子数组数量。...输出:6。 解释: 总共有 6 个子数组满足第一个元素和最后一个元素都是子数组中的最大值: 子数组 [1,4,3,3,2] 的1,最大元素为 1 ,第一个和最后一个元素都是 1 。...子数组 [1,4,3,3,2] 的4,最大元素为 4 ,第一个和最后一个元素都是 4 。 子数组 [1,4,3,3,2]的第1个3 ,最大元素为 3 ,第一个和最后一个元素都是 3 。...子数组 [1,4,3,3,2] 的第2个3,最大元素为 3 ,第一个和最后一个元素都是 3 。 子数组 [1,4,3,3,2]的2 ,最大元素为 2 ,第一个和最后一个元素都是 2 。...子数组 [1,4,3,3,2] 的[3,3],最大元素为 3 ,第一个和最后一个元素都是 3 。 所以我们返回 6 。

    1.1K20
    领券